#include <stdio.h>
#include "utilityfast.h"

int
main(int argc, char *argv[]){
  char *string1, *aligned1; /* first string input, and the aligned output*/
  char *string2, *aligned2; /* second string input, and the aligned output*/
  char *graphic; /* printed between the strings, shows '|' for match, or '*'
		  * for mismatch*/
  int over = 1;
  int line = 0;
  int highscore=0; /* stores total score*/
  int counter = 0;
  char c = 0;
  int i,j=0;
  int edge=0; /* used as a boolean value*/
  int size1=0; /* size of first string*/
  int size2=0; /* size of second string*/
  struct spot **matrix; /* holds matrix of structures*/
  struct highscore **highs; /* holds matrix of high-scores*/
  struct spot *hmax;
  struct spot *vmax;
  struct spot *totalmax;
  int maxscore=0;
  string1 =(char*) malloc(50);
  string2 =(char*) malloc(50);
  /* first get the two sequences and store them in arrays, reallocating memory
   * after every 50 characters, and keeping track of the total number of 
   * of characters in each array.*/
  while((c = getchar()) != '\n'){
    if(size1 > (50*over-1)){
      over++;
      string1=(char *)realloc(string1, over*50);
    }
    string1[size1] = c;
    size1++;
  }
  over=1;
  while(((c=getchar()) != '\n')&&(c != EOF)){
    if(size2 > (50*over-1)){
      over++;
      string2=(char *)realloc(string2, over*50);
    }
    string2[size2] = c;
    size2++;
  }
  /* now allocate memory for matrices*/
  matrix = (struct spot **) malloc(sizeof(struct spot*)*size2);
  for(i=0;i<size2;i++){
    matrix[i]=(struct spot *) malloc(sizeof(struct spot)*size1);
  }
  highs = (struct highscore **) malloc(sizeof(struct highscore*) * (size2-1));
  for (i=0;i<size2-1;i++){
    highs[i]=(struct highscore *) malloc(sizeof(struct highscore) * (size1-1));
  }
  /* create sum matrix, keeping track of the source of the score for each 
   * element.  this algorithm holds previous high scores in a matrix, and
   * then only need to compare the previous high row and column scores with
   * the value of matrix[i+1][j+1]*/
  for(i=(size2-1);i>=0;i--){
    for(j=(size1-1);j>=0;j--){
      edge=0;
      /* store the indices in the structure, and make the score 1 if the 
       * characters from the respective strings are the same*/
      matrix[i][j].rowindex=i;
      matrix[i][j].columnindex=j;
      if(string1[j]==string2[i])
	matrix[i][j].score=1;
      else
	matrix[i][j].score=0;
      /* now cycle through, taking appropriate measures for an element
       * depending on its location in the matrix - edge elements don't need
       * an entry in the highscore matrix*/
      if((j<size1-2)&&(i<size2-2)){ /* must search both column and row for the
				     * previous high score*/
	if(highs[i][j+1].hscore > matrix[i+1][j+1].score){
	  hmax=highs[i][j+1].hsource;
	  highs[i][j].hscore=highs[i][j+1].hscore;
	  highs[i][j].hsource=highs[i][j+1].hsource;
	}
	else{
	  hmax=&(matrix[i+1][j+1]);
	  highs[i][j].hscore=matrix[i+1][j+1].score;
	  highs[i][j].hsource=&(matrix[i+1][j+1]);
	}
	vmax=highs[i+1][j].vsource; /* compensates for not including
				     * matrix[i+1][j+1] in the original
				     * column comparison*/
	/* pick the highest of the two scores, keeping the high road in a tie*/
	if((hmax->score) > (vmax->score))
	  totalmax=hmax;
	if((hmax->score) < (vmax->score))
	  totalmax=vmax;
	if(hmax->score==vmax->score){
	  if((hmax->columnindex-j) > (vmax->rowindex-i))
	    totalmax=vmax;
	  else
	    totalmax=hmax;
	}
	if (vmax->score>matrix[i+1][j+1].score){
	  highs[i][j].vscore=vmax->score;
	  highs[i][j].vsource=vmax;
	}
	else{
	  highs[i][j].vscore=matrix[i+1][j+1].score;
	  highs[i][j].vsource=&(matrix[i+1][j+1]);
	}
      }
      if((j==size1-2)&&(i<size2-2)){
	hmax=&(matrix[i+1][j+1]);
	highs[i][j].hscore=hmax->score;
	highs[i][j].hsource=hmax;
	vmax=highs[i+1][j].vsource;
	if(vmax->score>hmax->score){
	  totalmax=vmax;
	  highs[i][j].vscore=vmax->score;
	  highs[i][j].vsource=vmax;
	}
	else{
	  totalmax=hmax;
	  highs[i][j].vscore=hmax->score;
	  highs[i][j].vsource=hmax;
	}
      }

      if((j<size1-2)&&(i==size2-2)){/* only need to check row for high score*/
	if(highs[i][j+1].hscore > matrix[i+1][j+1].score)
	  hmax=highs[i][j+1].hsource;
	else
	  hmax=&(matrix[i+1][j+1]);
	totalmax=hmax;
	highs[i][j].hscore=hmax->score;
	highs[i][j].hsource=hmax;
	highs[i][j].vscore=matrix[i+1][j+1].score;
	highs[i][j].vsource=&(matrix[i+1][j+1]);
      }
      if((i==size2-2)&&(j==size1-2)){
	totalmax=&(matrix[i+1][j+1]);
	highs[i][j].hscore=totalmax->score;
	highs[i][j].hsource=totalmax;
	highs[i][j].vscore=totalmax->score;
	highs[i][j].vsource=totalmax;
      }
      if((i==size2-1)||(j==size1-1)){/* flag the edge of the matrix*/
	edge=1;
	matrix[i][j].source=NULL;
      }
      if(edge!=1){/* calculate new score based on previous high and make
		   * pointer to the source of that high score for use in the
		   * traceback*/
	matrix[i][j].score=matrix[i][j].score+totalmax->score;
	matrix[i][j].source=totalmax;
      }
    }
  }
  /* check the top row and column of the matrix for the highest scoring
   * element (and starting point of the traceback)*/ 
  hmax=find_hmax(matrix, 0,0,size1);
  vmax=find_vmax(matrix, 0,1,size2);
  if(hmax->score>vmax->score)
    totalmax=hmax;
  if(hmax->score<vmax->score)
    totalmax=vmax;
  if(hmax->score==vmax->score){
    if((hmax->columnindex)>(vmax->rowindex))
      totalmax=vmax;
    else
      totalmax=hmax;
  }
  highscore=totalmax->score;
  i=0;
  j=0; /* i and j are initially at the origin, but move to where a given high
	* scoring structure is in order to correct for spaces*/
  aligned1=(char *)malloc(size1+size2);/* worst case scenario for output size*/
  aligned2=(char *)malloc(size1+size2+2);
  graphic=(char *)malloc(size1+size2+2);
  
  while(totalmax != NULL){
    while(totalmax->columnindex != j){/* correct for spaces in string2*/
      aligned2[counter] = '-';
      aligned1[counter] = string1[j];
      graphic[counter]=' ';
      j++;
      counter++;
    }
    while(totalmax->rowindex != i){/* correct for spaces in string1*/
      aligned1[counter] = '-';
      aligned2[counter] = string2[i];
      graphic[counter]=' ';
      i++;
      counter++;
    }
    /* store the appropriate characters from input strings into the output
     * strings*/
    aligned1[counter]=string1[totalmax->columnindex];
    aligned2[counter]=string2[totalmax->rowindex];
    if(aligned1[counter]==aligned2[counter])
      graphic[counter] = '|';
    else
      graphic[counter] = '*';
    counter++;
    i++;
    j++;
    totalmax=totalmax->source;
    /* totalmax now points to the previous high score source.  i and j are
     * set to where the alignment would be if it proceeded without gaps*/
  }
  i--;
  j--;
  /* deal with any leftover spaces*/
  while(j != size1-1){
    j++;
    aligned1[counter]=string1[j];
    aligned2[counter]='-';
    counter++;
  }
  while(i != size2-1){
    i++;
    aligned2[counter]=string2[i];
    aligned1[counter]='-';
    counter++;
  }
  aligned1[counter]=0;
  aligned2[counter]=0;
  graphic[counter]=0;
  counter++;
  /* print out aligned sequences, making a new line every 80 characters*/
  while(1){
  for(i=0; (aligned1[80*line+i] != 0)&&(i<80); i++){
    printf("%c", aligned1[80*line+i]);
  }
  printf("\n");
  for(i=0; (graphic[80*line+i] != 0)&&(i<80); i++){
    printf("%c", graphic[80*line+i]);
  }
  printf("\n");
  for(i=0; (aligned2[80*line+i] !=0)&&(i<80);i++){
    printf("%c", aligned2[80*line+i]);
  }
  printf("\n");
  if(i==80){
    line++;
    printf("\n");
  }
  else
    break;
  }
  printf("Score: %d\n", highscore);
}
